package test.dao.impl;


import org.seasar.dao.DaoMetaDataFactory;
import org.seasar.dao.annotation.tiger.Arguments;
import org.seasar.dao.annotation.tiger.S2Dao;
import org.seasar.dao.annotation.tiger.Sql;
import org.seasar.dao.impl.AbstractDao;

import test.dao.TestTableDao;
import test.entity.TestTable;

@S2Dao(bean=TestTable.class)
public abstract class TestTableDaoImpl extends AbstractDao implements TestTableDao {

    public TestTableDaoImpl(DaoMetaDataFactory daoMetaDataFactory) {
        super(daoMetaDataFactory);
    }
    
    public abstract TestTable[] selectAll();

    @Arguments("ID")
    public abstract TestTable selectById(Integer id);

    @Sql("select count(*) from test_table")
    public abstract int selectCount();
    
    public boolean isCountZero() {
        int count = selectCount();
        if (count > 0) {
            return false;
        }
        return true;
    }

    public abstract int insert(TestTable table);

    public abstract int update(TestTable table);

    public abstract int delete(TestTable table);
    
    @Sql("delete from test_table")
    public abstract int deleteAll();
}
